/******************************************************************************/
/*!
 * \file timlCNNConvParamsDefault.c
 */
/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************/


/*******************************************************************************
 *
 * INCLUDES
 *
 ******************************************************************************/

#include "../api/timl.h"


/*******************************************************************************/
/*!
 * \ingroup cnn
 * \brief   Return the default parameters for the convolutional layer
 * \return  Default conv layer parameters
 */
/*******************************************************************************/

timlCNNConvParams timlCNNConvParamsDefault()
{
   timlCNNConvParams params;
   params.inputFeatureMapChannel     = -1;
   params.outputFeatureMapChannel    = -1;
   params.kernelRow                  = -1;
   params.kernelCol                  = -1;
   params.padUp                      = 0;
   params.padDown                    = 0;
   params.padLeft                    = 0;
   params.padRight                   = 0;
   params.strideX                    = 1;
   params.strideY                    = 1;
   params.prevFeatureMapReshape      = NULL;
   params.prevFeatureMapReshapeIndex = NULL;
   params.kernelGradAccum            = NULL;
   params.kernel                     = NULL;
   params.kernelInc                  = NULL;
   params.kernelDecayFactor          = 1.0;
   params.kernelLearningFactor       = 1.0;
   params.kernelInit.type            = Util_Xavier;
   params.connectivity               = NULL;
   params.bias                       = NULL;
   params.biasGradAccum              = NULL;
   params.biasInc                    = NULL;
   params.biasMultiplier             = NULL;
   params.biasLearningFactor         = 1.0;
   params.biasInit.type              = Util_Constant;
   params.biasInit.val               = 0.0;
   params.type                       = Util_Conv2D;
   params.shared                     = false;

   return params;
}

